/*
 * -----------------------------------------------------------------------
 *
 * NOTE: Do *not* edit this file; instead, edit 'erl_alloc.types' and
 *       build again! This file was automatically generated by
 *       'make_alloc_types' on Wed Apr 17 11:02:14 2019.
 *
 * -----------------------------------------------------------------------
 *
 * 
 * Copyright Ericsson AB 2019. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

#ifndef ERL_ALLOC_TYPES_H__
#define ERL_ALLOC_TYPES_H__


/* --- Allocator numbers -------------------------------------------------- */

#define ERTS_ALC_A_INVALID (0)

#define ERTS_ALC_A_MIN (1)

#define ERTS_ALC_A_SYSTEM (1)
#define ERTS_ALC_A_TEMPORARY (2)
#define ERTS_ALC_A_SHORT_LIVED (3)
#define ERTS_ALC_A_STANDARD (4)
#define ERTS_ALC_A_LONG_LIVED (5)
#define ERTS_ALC_A_EHEAP (6)
#define ERTS_ALC_A_ETS (7)
#define ERTS_ALC_A_FIXED_SIZE (8)
#define ERTS_ALC_A_LITERAL (9)
#define ERTS_ALC_A_EXEC (10)
#define ERTS_ALC_A_BINARY (11)
#define ERTS_ALC_A_DRIVER (12)
#define ERTS_ALC_A_TEST (13)

#define ERTS_ALC_A_MAX (13)


/* --- Class numbers ------------------------------------------------------ */

#define ERTS_ALC_C_INVALID (0)

#define ERTS_ALC_C_MIN (1)

#define ERTS_ALC_C_ATOM  (1)
#define ERTS_ALC_C_BINARIES  (2)
#define ERTS_ALC_C_CODE  (3)
#define ERTS_ALC_C_ETS  (4)
#define ERTS_ALC_C_PROCESSES  (5)
#define ERTS_ALC_C_SYSTEM  (6)

#define ERTS_ALC_C_MAX (6)


/* --- Type number intervals ---------------------------------------------- */

#define ERTS_ALC_N_INVALID (0)

#define ERTS_ALC_N_MIN (1)

/* Type numbers used for sys_alloc */
#define ERTS_ALC_N_MIN_A_SYSTEM (1)
#define ERTS_ALC_N_MAX_A_SYSTEM (4)

/* Type numbers used for temp_alloc */
#define ERTS_ALC_N_MIN_A_TEMPORARY (5)
#define ERTS_ALC_N_MAX_A_TEMPORARY (24)

/* Type numbers used for sl_alloc */
#define ERTS_ALC_N_MIN_A_SHORT_LIVED (25)
#define ERTS_ALC_N_MAX_A_SHORT_LIVED (80)

/* Type numbers used for std_alloc */
#define ERTS_ALC_N_MIN_A_STANDARD (81)
#define ERTS_ALC_N_MAX_A_STANDARD (124)

/* Type numbers used for ll_alloc */
#define ERTS_ALC_N_MIN_A_LONG_LIVED (125)
#define ERTS_ALC_N_MAX_A_LONG_LIVED (173)

/* Type numbers used for eheap_alloc */
#define ERTS_ALC_N_MIN_A_EHEAP (174)
#define ERTS_ALC_N_MAX_A_EHEAP (178)

/* Type numbers used for ets_alloc */
#define ERTS_ALC_N_MIN_A_ETS (179)
#define ERTS_ALC_N_MAX_A_ETS (187)

/* Type numbers used for fix_alloc */
#define ERTS_ALC_N_MIN_A_FIXED_SIZE (188)
#define ERTS_ALC_N_MAX_A_FIXED_SIZE (201)

/* Type numbers used for literal_alloc */
#define ERTS_ALC_N_MIN_A_LITERAL (202)
#define ERTS_ALC_N_MAX_A_LITERAL (202)

/* Type numbers used for exec_alloc */
#define ERTS_ALC_N_MIN_A_EXEC (203)
#define ERTS_ALC_N_MAX_A_EXEC (203)

/* Type numbers used for binary_alloc */
#define ERTS_ALC_N_MIN_A_BINARY (204)
#define ERTS_ALC_N_MAX_A_BINARY (205)

/* Type numbers used for driver_alloc */
#define ERTS_ALC_N_MIN_A_DRIVER (206)
#define ERTS_ALC_N_MAX_A_DRIVER (220)

/* Type numbers used for test_alloc */
#define ERTS_ALC_N_MIN_A_TEST (221)
#define ERTS_ALC_N_MAX_A_TEST (221)

#define ERTS_ALC_N_MAX (221)


/* --- Multi thread use of allocators -------------------------------------- */

#define ERTS_ALC_MTA_SYSTEM (1)
#define ERTS_ALC_MTA_TEMPORARY (1)
#define ERTS_ALC_MTA_SHORT_LIVED (1)
#define ERTS_ALC_MTA_STANDARD (1)
#define ERTS_ALC_MTA_LONG_LIVED (1)
#define ERTS_ALC_MTA_EHEAP (1)
#define ERTS_ALC_MTA_ETS (1)
#define ERTS_ALC_MTA_FIXED_SIZE (1)
#define ERTS_ALC_MTA_LITERAL (1)
#define ERTS_ALC_MTA_EXEC (1)
#define ERTS_ALC_MTA_BINARY (1)
#define ERTS_ALC_MTA_DRIVER (1)
#define ERTS_ALC_MTA_TEST (1)


/* --- Types --------------------------------------------------------------- */

typedef Uint32 ErtsAlcType_t; /* The type used for memory types */

#define ERTS_ALC_T_INVALID (0)

#define ERTS_ALC_T_UNDEF (225)
#define ERTS_ALC_T_NBIF_TABLE (353)
#define ERTS_ALC_T_INFO_DSBUF (481)
#define ERTS_ALC_T_PUTENV_STR (609)
#define ERTS_ALC_T_TMP_HEAP (722)
#define ERTS_ALC_T_MSG_ROOTS (850)
#define ERTS_ALC_T_ROOTSET (978)
#define ERTS_ALC_T_LOADER_TMP (1074)
#define ERTS_ALC_T_NC_TMP (1250)
#define ERTS_ALC_T_TMP (1378)
#define ERTS_ALC_T_DCTRL_BUF (1506)
#define ERTS_ALC_T_TMP_DIST_BUF (1634)
#define ERTS_ALC_T_ESTACK (1762)
#define ERTS_ALC_T_DB_TMP (1858)
#define ERTS_ALC_T_DB_MC_STK (1986)
#define ERTS_ALC_T_DB_MS_CMPL_HEAP (2114)
#define ERTS_ALC_T_LOGGER_DSBUF (2274)
#define ERTS_ALC_T_TMP_DSBUF (2402)
#define ERTS_ALC_T_DDLL_TMP_BUF (2530)
#define ERTS_ALC_T_RE_TMP_BUF (2658)
#define ERTS_ALC_T_TEMP_TERM (2786)
#define ERTS_ALC_T_SYS_READ_BUF (2914)
#define ERTS_ALC_T_ENVIRONMENT (3042)
#define ERTS_ALC_T_SYS_WRITE_BUF (3170)
#define ERTS_ALC_T_PEND_SUSPEND (3283)
#define ERTS_ALC_T_PROC_LIST (3411)
#define ERTS_ALC_T_SAVED_ESTACK (3539)
#define ERTS_ALC_T_MSGQ_CHNG (3667)
#define ERTS_ALC_T_PREPARED_CODE (3763)
#define ERTS_ALC_T_TIMER_REQUEST (3923)
#define ERTS_ALC_T_BTM_YIELD_STATE (4051)
#define ERTS_ALC_T_DB_FIXATION (4163)
#define ERTS_ALC_T_DB_FIX_DEL (4291)
#define ERTS_ALC_T_DB_MS_RUN_HEAP (4419)
#define ERTS_ALC_T_DB_PROC_CLEANUP (4547)
#define ERTS_ALC_T_ETS_ALL_REQ (4675)
#define ERTS_ALC_T_PORT_TASK (4835)
#define ERTS_ALC_T_PT_HNDL_LIST (4963)
#define ERTS_ALC_T_MISC_OP_LIST (5091)
#define ERTS_ALC_T_PORT_NAMES (5219)
#define ERTS_ALC_T_PTAB_LIST_DEL (5331)
#define ERTS_ALC_T_PTAB_LIST_CNKI (5459)
#define ERTS_ALC_T_PTAB_LIST_PIDS (5587)
#define ERTS_ALC_T_RE_SUBJECT (5731)
#define ERTS_ALC_T_RE_STACK (5859)
#define ERTS_ALC_T_UNICODE_BUFFER (5987)
#define ERTS_ALC_T_BINARY_BUFFER (6115)
#define ERTS_ALC_T_TMP_CPU_IDS (6243)
#define ERTS_ALC_T_EXT_TERM_DATA (6355)
#define ERTS_ALC_T_CODE_IX_LOCK_Q (6499)
#define ERTS_ALC_T_BUSY_CALLER_TAB (6627)
#define ERTS_ALC_T_BUSY_CALLER (6755)
#define ERTS_ALC_T_PROC_SYS_TSK (6867)
#define ERTS_ALC_T_PROC_SYS_TSK_QS (6995)
#define ERTS_ALC_T_NEW_TIME_OFFSET (7139)
#define ERTS_ALC_T_IOB_REQ (7267)
#define ERTS_ALC_T_TRACE_MSG_QUEUE (7395)
#define ERTS_ALC_T_SCHED_ASYNC_JOB (7523)
#define ERTS_ALC_T_DIRTY_SL (7651)
#define ERTS_ALC_T_MISC_AUX_WORK (7779)
#define ERTS_ALC_T_THR_Q_SL (7907)
#define ERTS_ALC_T_ASYNC (8035)
#define ERTS_ALC_T_XPORTS_LIST (8163)
#define ERTS_ALC_T_T_THR_PRGR_DATA (8291)
#define ERTS_ALC_T_RELEASE_LAREA (8419)
#define ERTS_ALC_T_LIST_TRAP (8531)
#define ERTS_ALC_T_ETHR_SL (8675)
#define ERTS_ALC_T_SYS_MSG_Q (8787)
#define ERTS_ALC_T_SL_MPATHS (8931)
#define ERTS_ALC_T_HIPE_SL (9059)
#define ERTS_ALC_T_DEBUG (9187)
#define ERTS_ALC_T_LITERAL_REF (9267)
#define ERTS_ALC_T_PURGE_DATA (9395)
#define ERTS_ALC_T_AINFO_REQ (9571)
#define ERTS_ALC_T_SCHED_WTIME_REQ (9699)
#define ERTS_ALC_T_GC_INFO_REQ (9827)
#define ERTS_ALC_T_SYS_CHECK_REQ (9955)
#define ERTS_ALC_T_FD_LIST (10083)
#define ERTS_ALC_T_ACTIVE_FD_ARR (10211)
#define ERTS_ALC_T_POLLSET_UPDREQ (10339)
#define ERTS_ALC_T_REG_PROC (10452)
#define ERTS_ALC_T_LINK_LH (10580)
#define ERTS_ALC_T_SUSPEND_MON (10708)
#define ERTS_ALC_T_REG_TABLE (10852)
#define ERTS_ALC_T_FUN_TABLE (10932)
#define ERTS_ALC_T_DIST_TABLE (11108)
#define ERTS_ALC_T_NODE_TABLE (11236)
#define ERTS_ALC_T_MODULE_REFS (11316)
#define ERTS_ALC_T_DCACHE (11492)
#define ERTS_ALC_T_DIST_ENTRY (11620)
#define ERTS_ALC_T_NODE_ENTRY (11748)
#define ERTS_ALC_T_ARG_REG (11860)
#define ERTS_ALC_T_PROC_DICT (11988)
#define ERTS_ALC_T_CALLS_BUF (12116)
#define ERTS_ALC_T_BPD (12260)
#define ERTS_ALC_T_LINEBUF (12388)
#define ERTS_ALC_T_IOQ (12516)
#define ERTS_ALC_T_BITS_BUF (12644)
#define ERTS_ALC_T_DB_NTAB_ENT (12740)
#define ERTS_ALC_T_DDLL_HANDLE (12900)
#define ERTS_ALC_T_NODES_MON (13012)
#define ERTS_ALC_T_RE_HEAP (13156)
#define ERTS_ALC_T_PSD (13268)
#define ERTS_ALC_T_PRTSD (13412)
#define ERTS_ALC_T_DIRTY_START (13524)
#define ERTS_ALC_T_MREF_ENT (13668)
#define ERTS_ALC_T_MREF_TAB_BKTS (13796)
#define ERTS_ALC_T_CRASH_DUMP (13924)
#define ERTS_ALC_T_THR_Q_EL (14052)
#define ERTS_ALC_T_THR_Q (14180)
#define ERTS_ALC_T_ZLIB (14308)
#define ERTS_ALC_T_PORT_LOCK (14436)
#define ERTS_ALC_T_DRIVER_LOCK (14564)
#define ERTS_ALC_T_ETHR_STD (14692)
#define ERTS_ALC_T_HIPE_STK (14820)
#define ERTS_ALC_T_DDLL_PROCESS (14948)
#define ERTS_ALC_T_MONITOR_LH (15060)
#define ERTS_ALC_T_NLINK_LH (15188)
#define ERTS_ALC_T_DB_HEIR_DATA (15300)
#define ERTS_ALC_T_NIF_TRAP_EXPORT (15444)
#define ERTS_ALC_T_PORT_DATA_HEAP (15588)
#define ERTS_ALC_T_FD_ENTRY_BUF (15716)
#define ERTS_ALC_T_PRT_REP_EXIT (15844)
#define ERTS_ALC_T_SYS_BLOCKING (15972)
#define ERTS_ALC_T_ATOM (16021)
#define ERTS_ALC_T_MODULE (16181)
#define ERTS_ALC_T_FUN_ENTRY (16309)
#define ERTS_ALC_T_ATOM_TXT (16405)
#define ERTS_ALC_T_TIMER_SERVICE (16613)
#define ERTS_ALC_T_ATOM_TABLE (16661)
#define ERTS_ALC_T_EXPORT_TABLE (16821)
#define ERTS_ALC_T_MODULE_TABLE (16949)
#define ERTS_ALC_T_TAINT (17077)
#define ERTS_ALC_T_PROC_TABLE (17237)
#define ERTS_ALC_T_PORT_TABLE (17381)
#define ERTS_ALC_T_TIMER_WHEEL (17509)
#define ERTS_ALC_T_ASYNC_DATA (17637)
#define ERTS_ALC_T_DB_TABLES (17733)
#define ERTS_ALC_T_INSTR_INFO (17893)
#define ERTS_ALC_T_SCHDLR_SLP_INFO (18021)
#define ERTS_ALC_T_RUNQS (18149)
#define ERTS_ALC_T_DDLL_ERRCODES (18277)
#define ERTS_ALC_T_PRE_ALLOC_DATA (18405)
#define ERTS_ALC_T_CPUDATA (18533)
#define ERTS_ALC_T_CPU_GRPS_MAP (18661)
#define ERTS_ALC_T_AUX_WORK_TMO (18789)
#define ERTS_ALC_T_MISC_AUX_WORK_Q (18917)
#define ERTS_ALC_T_PROC_INTERVAL (19045)
#define ERTS_ALC_T_TRACER_NIF (19173)
#define ERTS_ALC_T_MREF_TAB (19301)
#define ERTS_ALC_T_THR_Q_LL (19429)
#define ERTS_ALC_T_PROC_LCK_WTR (19557)
#define ERTS_ALC_T_RUNQ_BLNS (19685)
#define ERTS_ALC_T_THR_PRGR_IDATA (19813)
#define ERTS_ALC_T_THR_PRGR_DATA (19941)
#define ERTS_ALC_T_ETHR_LL (20069)
#define ERTS_ALC_T_FP_EXCEPTION (20197)
#define ERTS_ALC_T_LL_MPATHS (20325)
#define ERTS_ALC_T_HIPE_LL (20453)
#define ERTS_ALC_T_CODE (20533)
#define ERTS_ALC_T_DB_MS_PSDO_PROC (20677)
#define ERTS_ALC_T_SCHDLR_DATA (20837)
#define ERTS_ALC_T_LL_TEMP_TERM (20965)
#define ERTS_ALC_T_EXPORT (21045)
#define ERTS_ALC_T_DRV_TAB (21221)
#define ERTS_ALC_T_DRV_EV_STATE (21349)
#define ERTS_ALC_T_POLLSET (21477)
#define ERTS_ALC_T_POLL_FDS (21605)
#define ERTS_ALC_T_POLL_RES_EVS (21733)
#define ERTS_ALC_T_FD_STATUS (21861)
#define ERTS_ALC_T_SELECT_FDS (21989)
#define ERTS_ALC_T_FD_TAB (22117)
#define ERTS_ALC_T_CS_PROG_PATH (22245)
#define ERTS_ALC_T_BEAM_REGISTER (22358)
#define ERTS_ALC_T_HEAP (22486)
#define ERTS_ALC_T_OLD_HEAP (22614)
#define ERTS_ALC_T_HEAP_FRAG (22742)
#define ERTS_ALC_T_MSG (22870)
#define ERTS_ALC_T_DB_TABLE (22983)
#define ERTS_ALC_T_DB_SEG (23111)
#define ERTS_ALC_T_DB_SEG_TAB (23239)
#define ERTS_ALC_T_DB_STK (23367)
#define ERTS_ALC_T_DB_TRANS_TAB (23495)
#define ERTS_ALC_T_DB_SEL_LIST (23623)
#define ERTS_ALC_T_DB_DMC_ERROR (23751)
#define ERTS_ALC_T_DB_DMC_ERR_INFO (23879)
#define ERTS_ALC_T_DB_TERM (24007)
#define ERTS_ALC_T_PROC (24152)
#define ERTS_ALC_T_MSG_REF (24280)
#define ERTS_ALC_T_LL_PTIMER (24408)
#define ERTS_ALC_T_HL_PTIMER (24536)
#define ERTS_ALC_T_BIF_TIMER (24664)
#define ERTS_ALC_T_MREF_NSCHED_ENT (24808)
#define ERTS_ALC_T_MINDIRECTION (24936)
#define ERTS_ALC_T_THR_Q_EL_SL (25064)
#define ERTS_ALC_T_NIF_EXP_TRACE (25176)
#define ERTS_ALC_T_MONITOR_SH (25304)
#define ERTS_ALC_T_NLINK_SH (25432)
#define ERTS_ALC_T_DRV_EV_D_STATE (25576)
#define ERTS_ALC_T_DRV_SEL_D_STATE (25704)
#define ERTS_ALC_T_NIF_SEL_D_STATE (25832)
#define ERTS_ALC_T_LITERAL (25913)
#define ERTS_ALC_T_HIPE_EXEC (26042)
#define ERTS_ALC_T_DRV_BINARY (26155)
#define ERTS_ALC_T_BINARY (26283)
#define ERTS_ALC_T_PORT (26476)
#define ERTS_ALC_T_DRV (26604)
#define ERTS_ALC_T_DRIVER (26732)
#define ERTS_ALC_T_DRV_CMD_DATA (26860)
#define ERTS_ALC_T_DRV_CTRL_DATA (26988)
#define ERTS_ALC_T_DRV_CALL_DATA (27116)
#define ERTS_ALC_T_NIF (27244)
#define ERTS_ALC_T_PORT_DATA_LOCK (27372)
#define ERTS_ALC_T_DRV_THR_OPTS (27500)
#define ERTS_ALC_T_DRV_TID (27628)
#define ERTS_ALC_T_DRV_MTX (27756)
#define ERTS_ALC_T_DRV_CND (27884)
#define ERTS_ALC_T_DRV_RWLCK (28012)
#define ERTS_ALC_T_DRV_TSD (28140)
#define ERTS_ALC_T_MSACC (28268)
#define ERTS_ALC_T_TEST (28397)


/* --- Field sizes, masks, and shifts -------------------------------------- */

#define ERTS_ALC_A_BITS (4)
#define ERTS_ALC_C_BITS (3)
#define ERTS_ALC_N_BITS (8)
#define ERTS_ALC_T_BITS (15)

#define ERTS_ALC_A_MASK (15)
#define ERTS_ALC_C_MASK (7)
#define ERTS_ALC_N_MASK (255)
#define ERTS_ALC_T_MASK (32767)

#define ERTS_ALC_A_SHIFT (0)
#define ERTS_ALC_C_SHIFT (4)
#define ERTS_ALC_N_SHIFT (7)


/* --- Mappings ------------------------------------------------------------ */

/* type -> type number */
#define ERTS_ALC_T2N(T) (((T) >> ERTS_ALC_N_SHIFT) & ERTS_ALC_N_MASK)

/* type -> allocator number */
#define ERTS_ALC_T2A(T) (((T) >> ERTS_ALC_A_SHIFT) & ERTS_ALC_A_MASK)

/* type -> class number */
#define ERTS_ALC_T2C(T) (((T) >> ERTS_ALC_C_SHIFT) & ERTS_ALC_C_MASK)

/* type number -> type */
#define ERTS_ALC_N2T(N) (erts_alc_n2t[(N)])

/* type number -> type description */
#define ERTS_ALC_N2TD(N) (erts_alc_n2td[(N)])

/* type -> type description */
#define ERTS_ALC_T2TD(T) (ERTS_ALC_N2TD(ERTS_ALC_T2N((T))))

/* class number -> class description */
#define ERTS_ALC_C2CD(C) (erts_alc_c2cd[(C)])

/* allocator number -> allocator description */
#define ERTS_ALC_A2AD(A) (erts_alc_a2ad[(A)])

extern const ErtsAlcType_t erts_alc_n2t[];
extern const char *erts_alc_n2td[];
extern const char *erts_alc_c2cd[];
extern const char *erts_alc_a2ad[];

#ifdef ERTS_ALC_INTERNAL__

const ErtsAlcType_t erts_alc_n2t[] = {
  ERTS_ALC_T_INVALID,
  ERTS_ALC_T_UNDEF,
  ERTS_ALC_T_NBIF_TABLE,
  ERTS_ALC_T_INFO_DSBUF,
  ERTS_ALC_T_PUTENV_STR,
  ERTS_ALC_T_TMP_HEAP,
  ERTS_ALC_T_MSG_ROOTS,
  ERTS_ALC_T_ROOTSET,
  ERTS_ALC_T_LOADER_TMP,
  ERTS_ALC_T_NC_TMP,
  ERTS_ALC_T_TMP,
  ERTS_ALC_T_DCTRL_BUF,
  ERTS_ALC_T_TMP_DIST_BUF,
  ERTS_ALC_T_ESTACK,
  ERTS_ALC_T_DB_TMP,
  ERTS_ALC_T_DB_MC_STK,
  ERTS_ALC_T_DB_MS_CMPL_HEAP,
  ERTS_ALC_T_LOGGER_DSBUF,
  ERTS_ALC_T_TMP_DSBUF,
  ERTS_ALC_T_DDLL_TMP_BUF,
  ERTS_ALC_T_RE_TMP_BUF,
  ERTS_ALC_T_TEMP_TERM,
  ERTS_ALC_T_SYS_READ_BUF,
  ERTS_ALC_T_ENVIRONMENT,
  ERTS_ALC_T_SYS_WRITE_BUF,
  ERTS_ALC_T_PEND_SUSPEND,
  ERTS_ALC_T_PROC_LIST,
  ERTS_ALC_T_SAVED_ESTACK,
  ERTS_ALC_T_MSGQ_CHNG,
  ERTS_ALC_T_PREPARED_CODE,
  ERTS_ALC_T_TIMER_REQUEST,
  ERTS_ALC_T_BTM_YIELD_STATE,
  ERTS_ALC_T_DB_FIXATION,
  ERTS_ALC_T_DB_FIX_DEL,
  ERTS_ALC_T_DB_MS_RUN_HEAP,
  ERTS_ALC_T_DB_PROC_CLEANUP,
  ERTS_ALC_T_ETS_ALL_REQ,
  ERTS_ALC_T_PORT_TASK,
  ERTS_ALC_T_PT_HNDL_LIST,
  ERTS_ALC_T_MISC_OP_LIST,
  ERTS_ALC_T_PORT_NAMES,
  ERTS_ALC_T_PTAB_LIST_DEL,
  ERTS_ALC_T_PTAB_LIST_CNKI,
  ERTS_ALC_T_PTAB_LIST_PIDS,
  ERTS_ALC_T_RE_SUBJECT,
  ERTS_ALC_T_RE_STACK,
  ERTS_ALC_T_UNICODE_BUFFER,
  ERTS_ALC_T_BINARY_BUFFER,
  ERTS_ALC_T_TMP_CPU_IDS,
  ERTS_ALC_T_EXT_TERM_DATA,
  ERTS_ALC_T_CODE_IX_LOCK_Q,
  ERTS_ALC_T_BUSY_CALLER_TAB,
  ERTS_ALC_T_BUSY_CALLER,
  ERTS_ALC_T_PROC_SYS_TSK,
  ERTS_ALC_T_PROC_SYS_TSK_QS,
  ERTS_ALC_T_NEW_TIME_OFFSET,
  ERTS_ALC_T_IOB_REQ,
  ERTS_ALC_T_TRACE_MSG_QUEUE,
  ERTS_ALC_T_SCHED_ASYNC_JOB,
  ERTS_ALC_T_DIRTY_SL,
  ERTS_ALC_T_MISC_AUX_WORK,
  ERTS_ALC_T_THR_Q_SL,
  ERTS_ALC_T_ASYNC,
  ERTS_ALC_T_XPORTS_LIST,
  ERTS_ALC_T_T_THR_PRGR_DATA,
  ERTS_ALC_T_RELEASE_LAREA,
  ERTS_ALC_T_LIST_TRAP,
  ERTS_ALC_T_ETHR_SL,
  ERTS_ALC_T_SYS_MSG_Q,
  ERTS_ALC_T_SL_MPATHS,
  ERTS_ALC_T_HIPE_SL,
  ERTS_ALC_T_DEBUG,
  ERTS_ALC_T_LITERAL_REF,
  ERTS_ALC_T_PURGE_DATA,
  ERTS_ALC_T_AINFO_REQ,
  ERTS_ALC_T_SCHED_WTIME_REQ,
  ERTS_ALC_T_GC_INFO_REQ,
  ERTS_ALC_T_SYS_CHECK_REQ,
  ERTS_ALC_T_FD_LIST,
  ERTS_ALC_T_ACTIVE_FD_ARR,
  ERTS_ALC_T_POLLSET_UPDREQ,
  ERTS_ALC_T_REG_PROC,
  ERTS_ALC_T_LINK_LH,
  ERTS_ALC_T_SUSPEND_MON,
  ERTS_ALC_T_REG_TABLE,
  ERTS_ALC_T_FUN_TABLE,
  ERTS_ALC_T_DIST_TABLE,
  ERTS_ALC_T_NODE_TABLE,
  ERTS_ALC_T_MODULE_REFS,
  ERTS_ALC_T_DCACHE,
  ERTS_ALC_T_DIST_ENTRY,
  ERTS_ALC_T_NODE_ENTRY,
  ERTS_ALC_T_ARG_REG,
  ERTS_ALC_T_PROC_DICT,
  ERTS_ALC_T_CALLS_BUF,
  ERTS_ALC_T_BPD,
  ERTS_ALC_T_LINEBUF,
  ERTS_ALC_T_IOQ,
  ERTS_ALC_T_BITS_BUF,
  ERTS_ALC_T_DB_NTAB_ENT,
  ERTS_ALC_T_DDLL_HANDLE,
  ERTS_ALC_T_NODES_MON,
  ERTS_ALC_T_RE_HEAP,
  ERTS_ALC_T_PSD,
  ERTS_ALC_T_PRTSD,
  ERTS_ALC_T_DIRTY_START,
  ERTS_ALC_T_MREF_ENT,
  ERTS_ALC_T_MREF_TAB_BKTS,
  ERTS_ALC_T_CRASH_DUMP,
  ERTS_ALC_T_THR_Q_EL,
  ERTS_ALC_T_THR_Q,
  ERTS_ALC_T_ZLIB,
  ERTS_ALC_T_PORT_LOCK,
  ERTS_ALC_T_DRIVER_LOCK,
  ERTS_ALC_T_ETHR_STD,
  ERTS_ALC_T_HIPE_STK,
  ERTS_ALC_T_DDLL_PROCESS,
  ERTS_ALC_T_MONITOR_LH,
  ERTS_ALC_T_NLINK_LH,
  ERTS_ALC_T_DB_HEIR_DATA,
  ERTS_ALC_T_NIF_TRAP_EXPORT,
  ERTS_ALC_T_PORT_DATA_HEAP,
  ERTS_ALC_T_FD_ENTRY_BUF,
  ERTS_ALC_T_PRT_REP_EXIT,
  ERTS_ALC_T_SYS_BLOCKING,
  ERTS_ALC_T_ATOM,
  ERTS_ALC_T_MODULE,
  ERTS_ALC_T_FUN_ENTRY,
  ERTS_ALC_T_ATOM_TXT,
  ERTS_ALC_T_TIMER_SERVICE,
  ERTS_ALC_T_ATOM_TABLE,
  ERTS_ALC_T_EXPORT_TABLE,
  ERTS_ALC_T_MODULE_TABLE,
  ERTS_ALC_T_TAINT,
  ERTS_ALC_T_PROC_TABLE,
  ERTS_ALC_T_PORT_TABLE,
  ERTS_ALC_T_TIMER_WHEEL,
  ERTS_ALC_T_ASYNC_DATA,
  ERTS_ALC_T_DB_TABLES,
  ERTS_ALC_T_INSTR_INFO,
  ERTS_ALC_T_SCHDLR_SLP_INFO,
  ERTS_ALC_T_RUNQS,
  ERTS_ALC_T_DDLL_ERRCODES,
  ERTS_ALC_T_PRE_ALLOC_DATA,
  ERTS_ALC_T_CPUDATA,
  ERTS_ALC_T_CPU_GRPS_MAP,
  ERTS_ALC_T_AUX_WORK_TMO,
  ERTS_ALC_T_MISC_AUX_WORK_Q,
  ERTS_ALC_T_PROC_INTERVAL,
  ERTS_ALC_T_TRACER_NIF,
  ERTS_ALC_T_MREF_TAB,
  ERTS_ALC_T_THR_Q_LL,
  ERTS_ALC_T_PROC_LCK_WTR,
  ERTS_ALC_T_RUNQ_BLNS,
  ERTS_ALC_T_THR_PRGR_IDATA,
  ERTS_ALC_T_THR_PRGR_DATA,
  ERTS_ALC_T_ETHR_LL,
  ERTS_ALC_T_FP_EXCEPTION,
  ERTS_ALC_T_LL_MPATHS,
  ERTS_ALC_T_HIPE_LL,
  ERTS_ALC_T_CODE,
  ERTS_ALC_T_DB_MS_PSDO_PROC,
  ERTS_ALC_T_SCHDLR_DATA,
  ERTS_ALC_T_LL_TEMP_TERM,
  ERTS_ALC_T_EXPORT,
  ERTS_ALC_T_DRV_TAB,
  ERTS_ALC_T_DRV_EV_STATE,
  ERTS_ALC_T_POLLSET,
  ERTS_ALC_T_POLL_FDS,
  ERTS_ALC_T_POLL_RES_EVS,
  ERTS_ALC_T_FD_STATUS,
  ERTS_ALC_T_SELECT_FDS,
  ERTS_ALC_T_FD_TAB,
  ERTS_ALC_T_CS_PROG_PATH,
  ERTS_ALC_T_BEAM_REGISTER,
  ERTS_ALC_T_HEAP,
  ERTS_ALC_T_OLD_HEAP,
  ERTS_ALC_T_HEAP_FRAG,
  ERTS_ALC_T_MSG,
  ERTS_ALC_T_DB_TABLE,
  ERTS_ALC_T_DB_SEG,
  ERTS_ALC_T_DB_SEG_TAB,
  ERTS_ALC_T_DB_STK,
  ERTS_ALC_T_DB_TRANS_TAB,
  ERTS_ALC_T_DB_SEL_LIST,
  ERTS_ALC_T_DB_DMC_ERROR,
  ERTS_ALC_T_DB_DMC_ERR_INFO,
  ERTS_ALC_T_DB_TERM,
  ERTS_ALC_T_PROC,
  ERTS_ALC_T_MSG_REF,
  ERTS_ALC_T_LL_PTIMER,
  ERTS_ALC_T_HL_PTIMER,
  ERTS_ALC_T_BIF_TIMER,
  ERTS_ALC_T_MREF_NSCHED_ENT,
  ERTS_ALC_T_MINDIRECTION,
  ERTS_ALC_T_THR_Q_EL_SL,
  ERTS_ALC_T_NIF_EXP_TRACE,
  ERTS_ALC_T_MONITOR_SH,
  ERTS_ALC_T_NLINK_SH,
  ERTS_ALC_T_DRV_EV_D_STATE,
  ERTS_ALC_T_DRV_SEL_D_STATE,
  ERTS_ALC_T_NIF_SEL_D_STATE,
  ERTS_ALC_T_LITERAL,
  ERTS_ALC_T_HIPE_EXEC,
  ERTS_ALC_T_DRV_BINARY,
  ERTS_ALC_T_BINARY,
  ERTS_ALC_T_PORT,
  ERTS_ALC_T_DRV,
  ERTS_ALC_T_DRIVER,
  ERTS_ALC_T_DRV_CMD_DATA,
  ERTS_ALC_T_DRV_CTRL_DATA,
  ERTS_ALC_T_DRV_CALL_DATA,
  ERTS_ALC_T_NIF,
  ERTS_ALC_T_PORT_DATA_LOCK,
  ERTS_ALC_T_DRV_THR_OPTS,
  ERTS_ALC_T_DRV_TID,
  ERTS_ALC_T_DRV_MTX,
  ERTS_ALC_T_DRV_CND,
  ERTS_ALC_T_DRV_RWLCK,
  ERTS_ALC_T_DRV_TSD,
  ERTS_ALC_T_MSACC,
  ERTS_ALC_T_TEST,
  ERTS_ALC_T_INVALID
};

const char *erts_alc_n2td[] = {
  "invalid_type",
  "undefined",
  "nbif_tab",
  "info_dsbuf",
  "putenv_string",
  "tmp_heap",
  "msg_roots",
  "root_set",
  "loader_tmp",
  "nc_tmp",
  "tmp",
  "dctrl_buf",
  "tmp_dist_buf",
  "estack",
  "db_tmp",
  "db_mc_stack",
  "db_match_spec_cmpl_heap",
  "logger_dsbuf",
  "tmp_dsbuf",
  "ddll_tmp_buf",
  "re_tmp_buf",
  "temp_term",
  "sys_read_buf",
  "environment",
  "sys_write_buf",
  "pending_suspend",
  "proc_list",
  "saved_estack",
  "messages_queue_change",
  "prepared_code",
  "timer_request",
  "btm_yield_state",
  "db_fixation",
  "fixed_del",
  "db_match_spec_run_heap",
  "db_proc_cleanup_state",
  "ets_all_request",
  "port_task",
  "port_task_handle_list",
  "misc_op_list",
  "port_names",
  "ptab_list_deleted_el",
  "ptab_list_chunk_info",
  "ptab_list_pids",
  "re_subject",
  "re_stack",
  "unicode_buffer",
  "binary_buffer",
  "tmp_cpu_ids",
  "external_term_data",
  "code_ix_lock_q",
  "busy_caller_table",
  "busy_caller",
  "proc_sys_task",
  "proc_sys_task_queues",
  "new_time_offset",
  "io_bytes_request",
  "trace_message_queue",
  "async_calls",
  "dirty_short_lived",
  "misc_aux_work",
  "short_lived_thr_queue",
  "async",
  "extra_port_list",
  "temp_thr_prgr_data",
  "release_literal_area",
  "list_bif_trap_state",
  "ethread_short_lived",
  "system_messages_queue",
  "sl_migration_paths",
  "hipe_short_lived",
  "debugging",
  "literal_area_ref",
  "purge_data",
  "alloc_info_request",
  "sched_wall_time_request",
  "gc_info_request",
  "system_check_request",
  "fd_list",
  "active_fd_array",
  "pollset_update_req",
  "reg_proc",
  "link_lh",
  "suspend_monitor",
  "reg_tab",
  "fun_tab",
  "dist_tab",
  "node_tab",
  "module_refs",
  "dcache",
  "dist_entry",
  "node_entry",
  "arg_reg",
  "proc_dict",
  "calls_buf",
  "bpd",
  "line_buf",
  "io_queue",
  "bits_buf",
  "db_named_table_entry",
  "ddll_handle",
  "nodes_monitor",
  "re_heap",
  "process_specific_data",
  "port_specific_data",
  "dirty_start",
  "magic_ref_entry",
  "magic_ref_table_buckets",
  "crash_dump",
  "thr_q_element",
  "thr_queue",
  "zlib",
  "port_lock",
  "driver_lock",
  "ethread_standard",
  "hipe_nstack",
  "ddll_processes",
  "monitor_lh",
  "nlink_lh",
  "db_heir_data",
  "nif_trap_export_entry",
  "port_data_heap",
  "fd_entry_buf",
  "port_report_exit",
  "sys_blocking",
  "atom_entry",
  "module_entry",
  "fun_entry",
  "atom_text",
  "timer_service",
  "atom_tab",
  "export_tab",
  "module_tab",
  "taint_list",
  "proc_tab",
  "port_tab",
  "timer_wheel",
  "internal_async_data",
  "db_tabs",
  "instr_info",
  "scheduler_sleep_info",
  "run_queues",
  "ddll_errcodes",
  "pre_alloc_data",
  "cpu_data",
  "cpu_groups_map",
  "aux_work_timeouts",
  "misc_aux_work_q",
  "process_interval",
  "tracer_nif",
  "magic_ref_table",
  "long_lived_thr_queue",
  "proc_lock_waiter",
  "run_queue_balancing",
  "thr_prgr_internal_data",
  "thr_prgr_data",
  "ethread_long_lived",
  "fp_exception",
  "ll_migration_paths",
  "hipe_long_lived",
  "code",
  "db_match_pseudo_proc",
  "scheduler_data",
  "ll_temp_term",
  "export_entry",
  "drv_tab",
  "driver_event_state",
  "pollset",
  "poll_fds",
  "poll_result_events",
  "fd_status",
  "select_fds",
  "fd_tab",
  "cs_prog_path",
  "beam_register",
  "heap",
  "old_heap",
  "heap_frag",
  "message",
  "db_tab",
  "db_segment",
  "db_segment_tab",
  "db_stack",
  "db_trans_tab",
  "db_select_list",
  "db_dmc_error",
  "db_dmc_error_info",
  "db_term",
  "proc",
  "msg_ref",
  "ll_ptimer",
  "hl_ptimer",
  "bif_timer",
  "nsched_magic_ref_entry",
  "magic_indirection",
  "sl_thr_q_element",
  "nif_export_trace",
  "monitor_sh",
  "nlink_sh",
  "driver_event_data_state",
  "driver_select_data_state",
  "enif_select_data_state",
  "literal",
  "hipe_code",
  "drv_binary",
  "binary",
  "port",
  "drv_internal",
  "driver",
  "driver_command_data",
  "driver_control_data",
  "driver_call_data",
  "nif_internal",
  "port_data_lock",
  "driver_thread_opts",
  "driver_tid",
  "driver_mutex",
  "driver_cond",
  "driver_rwlock",
  "driver_tsd",
  "microstate_accounting",
  "testing",
  NULL
};

const char *erts_alc_c2cd[] = {
  "invalid_class",
  "atom_data",
  "binary_data",
  "code_data",
  "ets_data",
  "process_data",
  "system_data",
  NULL
};

const char *erts_alc_a2ad[] = {
  "invalid_allocator",
  "sys_alloc",
  "temp_alloc",
  "sl_alloc",
  "std_alloc",
  "ll_alloc",
  "eheap_alloc",
  "ets_alloc",
  "fix_alloc",
  "literal_alloc",
  "exec_alloc",
  "binary_alloc",
  "driver_alloc",
  "test_alloc",
  NULL
};

#endif /* #ifdef ERTS_ALC_INTERNAL__ */


/* ------------------------------------------------------------------------- */
#endif /* #ifndef ERL_ALLOC_TYPES_H__ */
